
# Domore Api

[![TesterHome](https://img.shields.io/badge/TTF-TesterHome-2955C5.svg)](https://testerhome.com/github_statistics)

*Domore Api* is a quick and handy tool for http(s) api testing. Enjoy it! ✨ 🚀 ✨

## Design Philosophy

- Convention over configuration
- ROI matters
- Embrace open source, leverage [`requests`][requests], [`pytest`][pytest], [`pydantic`][pydantic], [`allure`][allure], [`pytest-html`][pytest-html] and [`locust`][locust].

## Key Features

- [x] Inherit all powerful features of [`requests`][requests], just have fun to handle HTTP(S) in human way.
- [x] Define testcase in YAML or JSON format, run with [`pytest`][pytest] in concise and elegant manner.
- [x] Record and generate testcases with [`HAR`][HAR] support.
- [x] Supports `variables`/`extract`/`validate`/`hooks` mechanisms to create extremely complex test scenarios.
- [x] With `debugtalk.py` plugin, any function can be used in any part of your testcase.
- [x] With [`jmespath`][jmespath], extract and validate json response has never been easier.
- [x] With [`pytest`][pytest], hundreds of plugins are readily available.
- [x] With [`allure`][allure] or [`pytest-html`][pytest-html], test report can be pretty nice and powerful.
- [x] With reuse of [`locust`][locust], you can run performance test without extra work.
- [x] CLI command supported, perfect combination with `CI/CD`.

## Sponsors

Thank you to all our sponsors! ✨🍰✨


[requests]: http://docs.python-requests.org/en/master/
[pytest]: https://docs.pytest.org/
[pydantic]: https://pydantic-docs.helpmanual.io/
[locust]: http://locust.io/
[jmespath]: https://jmespath.org/
[allure]: https://docs.qameta.io/allure/
[pytest-html]: https://pytest-html.readthedocs.io/en/latest/
[HAR]: http://httparchive.org/
